--
-- @Interface: 1.5.1.0 b1580
-- @Author: GtX
-- @Date: 15.03.2018
-- @Version: 1.0.0.0
--
-- @Support: https://ls-modcompany.com
--

HPSFillBackpackEvent = {}
HPSFillBackpackEvent_mt = Class(HPSFillBackpackEvent, Event)
InitEventClass(HPSFillBackpackEvent, "HPSFillBackpackEvent")

function HPSFillBackpackEvent:emptyNew()
    local self = Event:new(HPSFillBackpackEvent_mt)
    return self
end;

function HPSFillBackpackEvent:new(equipment, saplingPallet)
    local self = HPSFillBackpackEvent:emptyNew()
    self.equipment = equipment
    self.saplingPallet = saplingPallet
    return self
end;

function HPSFillBackpackEvent:readStream(streamId, connection)
    self.equipment = readNetworkNodeObject(streamId)
    self.saplingPallet = readNetworkNodeObjectId(streamId)
    self:run(connection)
end

function HPSFillBackpackEvent:writeStream(streamId, connection)
    writeNetworkNodeObject(streamId, self.equipment)
    writeNetworkNodeObjectId(streamId, self.saplingPallet)
end

function HPSFillBackpackEvent:run(connection)
    if not connection:getIsServer() then
		self.equipment:setSaplingPalletLevel(self.saplingPallet)
    end
end