--
-- @Interface: 1.5.1.0 b1580
-- @Author: GtX
-- @Date: 15.03.2018
-- @Version: 1.0.0.0
--
-- @Support: https://ls-modcompany.com
--

HPSPlantingEvent = {}
HPSPlantingEvent_mt = Class(HPSPlantingEvent, Event)
InitEventClass(HPSPlantingEvent, "HPSPlantingEvent")

function HPSPlantingEvent:emptyNew()
    local self = Event:new(HPSPlantingEvent_mt)
    return self
end

function HPSPlantingEvent:new(equipment, x, y, z, treeType, backpackLevel)
    local self = HPSPlantingEvent:emptyNew()
	self.equipment = equipment
	self.xPlace = x
	self.yPlace = y
	self.zPlace = z
	self.treeType = treeType
	self.backpackLevel = backpackLevel
    return self
end

function HPSPlantingEvent:readStream(streamId, connection)
	self.equipment = readNetworkNodeObject(streamId)
	self.xPlace = streamReadFloat32(streamId)
	self.yPlace = streamReadFloat32(streamId)
	self.zPlace = streamReadFloat32(streamId)
	self.treeType = streamReadInt8(streamId)
	self.backpackLevel = streamReadInt8(streamId)
	self:run(connection);
end

function HPSPlantingEvent:writeStream(streamId, connection)
	writeNetworkNodeObject(streamId, self.equipment)
	streamWriteFloat32(streamId, self.xPlace)
	streamWriteFloat32(streamId, self.yPlace)
	streamWriteFloat32(streamId, self.zPlace)
	streamWriteInt8(streamId, self.treeType)
	streamWriteInt8(streamId, self.backpackLevel)
end

function HPSPlantingEvent:run(connection)
	if TreePlantUtil.canPlantTree() then
		if g_server then
			if self.equipment ~= nil then
				self.equipment:plantSapling(self.xPlace, self.yPlace, self.zPlace, self.treeType, self.backpackLevel)
			end
		end
	end
end