--
-- @Interface: 1.5.1.0 b1580
-- @Author: GtX
-- @Date: 15.03.2018
-- @Version: 1.0.0.0
--
-- @Support: https://ls-modcompany.com
--

HPSSetBackpackEvent = {}
HPSSetBackpackEvent_mt = Class(HPSSetBackpackEvent, Event)
InitEventClass(HPSSetBackpackEvent, "HPSSetBackpackEvent")

function HPSSetBackpackEvent:emptyNew()
	local self = Event:new(HPSSetBackpackEvent_mt)
    return self
end

function HPSSetBackpackEvent:new(equipment, fillLevel, treeType)
	local self = HPSSetBackpackEvent:emptyNew()
	self.equipment = equipment
	self.fillLevel = fillLevel
	self.treeType = treeType
	return self
end

function HPSSetBackpackEvent:readStream(streamId, connection)
	self.equipment = readNetworkNodeObject(streamId)
	self.fillLevel = streamReadInt8(streamId)
	self.treeType = streamReadInt8(streamId)
	self:run(connection)
end

function HPSSetBackpackEvent:writeStream(streamId, connection)
	writeNetworkNodeObject(streamId, self.equipment)
	streamWriteInt8(streamId, self.fillLevel)
	streamWriteInt8(streamId, self.treeType)
end

function HPSSetBackpackEvent:run(connection)
    if self.equipment ~= nil then
        self.equipment:setBackpack(self.fillLevel, self.treeType, true)
    end

    if not connection:getIsServer() then
        g_server:broadcastEvent(HPSSetBackpackEvent:new(self.equipment, self.fillLevel, self.treeType), nil, connection, self.equipment)
    end
end

function HPSSetBackpackEvent.sendEvent(equipment, fillLevel, treeType, noEventSend)
    if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(HPSSetBackpackEvent:new(equipment, fillLevel, treeType), nil, nil, equipment)
		else
			g_client:getServerConnection():sendEvent(HPSSetBackpackEvent:new(equipment, fillLevel, treeType))
		end
    end
end