--
-- @Interface: 1.5.1.0 b1580
-- @Author: GtX
-- @Date: 15.03.2018
-- @Version: 1.0.0.0
--
-- @Support: https://ls-modcompany.com
--

HPSSetEquipmentEvent = {}
HPSSetEquipmentEvent_mt = Class(HPSSetEquipmentEvent, Event)
InitEventClass(HPSSetEquipmentEvent, "HPSSetEquipmentEvent")

function HPSSetEquipmentEvent:emptyNew()
    local self = Event:new(HPSSetEquipmentEvent_mt)
    return self
end;

function HPSSetEquipmentEvent:new(equipment, isUsed, player)
    local self = HPSSetEquipmentEvent:emptyNew()
    self.equipment = equipment
    self.isUsed = isUsed
    self.player = player

    return self
end

function HPSSetEquipmentEvent:readStream(streamId, connection)
    self.equipment = readNetworkNodeObject(streamId)
    self.isUsed = streamReadBool(streamId)
    if self.isUsed then
        self.player = readNetworkNodeObject(streamId)
    end;
    self:run(connection)
end

function HPSSetEquipmentEvent:writeStream(streamId, connection)
    writeNetworkNodeObject(streamId, self.equipment)
    streamWriteBool(streamId, self.isUsed)
    if self.isUsed then
        writeNetworkNodeObject(streamId, self.player)
    end
end

function HPSSetEquipmentEvent:run(connection)
    if not connection:getIsServer() then
        g_server:broadcastEvent(self, false, connection, self.equipment)
    end;
    self.equipment:setEquipmentUsed(self.isUsed, self.player, true)
end

function HPSSetEquipmentEvent.sendEvent(equipment, isUsed, player, noEventSend)
    if isUsed ~= equipment.isUsed then
        if noEventSend == nil or noEventSend == false then
            if g_server ~= nil then
                g_server:broadcastEvent(HPSSetEquipmentEvent:new(equipment, isUsed, player), nil, nil, equipment)
            else
                g_client:getServerConnection():sendEvent(HPSSetEquipmentEvent:new(equipment, isUsed, player))
            end
        end
    end
end