--
-- @Interface: 1.5.1.0 b1580
-- @Author: GtX
-- @Date: 15.03.2018
-- @Version: 1.0.0.0
--
-- @Support: https://ls-modcompany.com
--

HPSSetStorageEvent = {}
HPSSetStorageEvent_mt = Class(HPSSetStorageEvent, Event)
InitEventClass(HPSSetStorageEvent, "HPSSetStorageEvent")

function HPSSetStorageEvent:emptyNew()
	local self = Event:new(HPSSetStorageEvent_mt)
    return self
end

function HPSSetStorageEvent:new(equipment, fillLevel, treeType)
	local self = HPSSetStorageEvent:emptyNew()
	self.equipment = equipment
	self.fillLevel = fillLevel
	self.treeType = treeType
	return self
end

function HPSSetStorageEvent:readStream(streamId, connection)
	self.equipment = readNetworkNodeObject(streamId)
	self.fillLevel = streamReadInt8(streamId)
	self.treeType = streamReadFloat32(streamId)
	self:run(connection)
end

function HPSSetStorageEvent:writeStream(streamId, connection)
	writeNetworkNodeObject(streamId, self.equipment)
	streamWriteInt8(streamId, self.fillLevel)
	streamWriteFloat32(streamId, self.treeType)
end

function HPSSetStorageEvent:run(connection)
    if self.equipment ~= nil then
        self.equipment:setStorage(self.fillLevel, self.treeType, true)
    end

    if not connection:getIsServer() then
        g_server:broadcastEvent(HPSSetStorageEvent:new(self.equipment, self.fillLevel, self.treeType), nil, connection, self.equipment)
    end
end

function HPSSetStorageEvent.sendEvent(equipment, fillLevel, treeType, noEventSend)
    if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(HPSSetStorageEvent:new(equipment, fillLevel, treeType), nil, nil, equipment)
		else
			g_client:getServerConnection():sendEvent(HPSSetStorageEvent:new(equipment, fillLevel, treeType))
		end
    end
end