--
-- @Interface: 1.5.1.0 b1580
-- @Author: GtX
-- @Date: 15.03.2018
-- @Version: 1.0.0.0
--
-- @Support: https://ls-modcompany.com
--

HPSSetUserEvent = {}
HPSSetUserEvent_mt = Class(HPSSetUserEvent, Event)
InitEventClass(HPSSetUserEvent, "HPSSetUserEvent")

function HPSSetUserEvent:emptyNew()
	local self = Event:new(HPSSetUserEvent_mt)
    return self
end

function HPSSetUserEvent:new(object, adminOnly)
	local self = HPSSetUserEvent:emptyNew()
	self.object = object
	self.adminOnly = adminOnly
	return self
end

function HPSSetUserEvent:readStream(streamId, connection)
	self.object = readNetworkNodeObject(streamId)
	self.adminOnly = streamReadBool(streamId)
	self:run(connection)
end

function HPSSetUserEvent:writeStream(streamId, connection)
	writeNetworkNodeObject(streamId, self.object)
	streamWriteBool(streamId, self.adminOnly)
end

function HPSSetUserEvent:run(connection)
	if self.object ~= nil then
        self.object.adminUsersOnly = self.adminOnly

		if not connection:getIsServer() then
			g_server:broadcastEvent(HPSSetUserEvent:new(self.object, self.adminOnly), nil, connection, self.object)
		end
	end
end